"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformerInterceptor = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const lodash_1 = require("lodash");
const rxjs_1 = require("rxjs");
const meta_storage_1 = require("../meta-storage/meta-storage");
let TransformerInterceptor = class TransformerInterceptor {
    constructor(_moduleRef) {
        this._moduleRef = _moduleRef;
    }
    intercept(context, next) {
        return next.handle().pipe((0, rxjs_1.switchMap)((body) => {
            const promises = this._inPlaceTransform(body);
            return (0, rxjs_1.of)(Promise.allSettled(promises).then(() => body));
        }));
    }
    _inPlaceTransform(object, type, promises = []) {
        var _a, _b, _c;
        type = type !== null && type !== void 0 ? type : object.constructor;
        if ((0, lodash_1.isArray)(object)) {
            object.forEach((_obj) => this._inPlaceTransform(_obj, undefined, promises));
            return promises;
        }
        if (!(0, lodash_1.isObject)(object)) {
            return promises;
        }
        const metarecords = type
            ? (_a = meta_storage_1.MetaStorage.instance().findTransformerMetadata(type)) !== null && _a !== void 0 ? _a : []
            : [];
        promises.push(...metarecords.map((metarecord) => __awaiter(this, void 0, void 0, function* () {
            const transformer = this._moduleRef.get(metarecord.transformer);
            object[metarecord.propertyName] = yield transformer.transform({
                key: metarecord.propertyName,
                obj: object,
                options: metarecord.options,
                value: object[metarecord.propertyName],
            });
        })));
        const nested = (0, lodash_1.entries)((0, lodash_1.pickBy)(Object.assign({}, object), lodash_1.isObject));
        if (nested.length === 0) {
            return promises;
        }
        for (const [key, value] of nested) {
            const propType = ((_b = value.constructor) !== null && _b !== void 0 ? _b : !!type)
                ? (_c = meta_storage_1.MetaStorage.instance().findTypeMetadata(type, key)) === null || _c === void 0 ? void 0 : _c.typeFunction
                : undefined;
            this._inPlaceTransform(value, propType === null || propType === void 0 ? void 0 : propType(), promises);
        }
        return promises;
    }
};
TransformerInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.ModuleRef])
], TransformerInterceptor);
exports.TransformerInterceptor = TransformerInterceptor;
