"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Type = void 0;
const meta_storage_1 = require("../meta-storage/meta-storage");
function Type(typeFunction, options = {}) {
    return function (target, propertyName) {
        try {
            const ClassTransformer = require("class-transformer");
            ClassTransformer.Type(typeFunction, options)(target, propertyName);
        }
        catch (error) { }
        const reflectedType = Reflect.getMetadata("design:type", target, propertyName);
        meta_storage_1.MetaStorage.instance().addTypeMetadata({
            target: target.constructor,
            propertyName: propertyName,
            reflectedType,
            typeFunction,
            options,
        });
    };
}
exports.Type = Type;
